unit mainUnit;
{Autor: 28}
{CESTINA je na STANDARTNI VECI nepouzitelna!!!! - nici prehlednost!!!}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ShellAPI, Buttons, ExtCtrls, Menus;


//type mfile=file of char;

type
  TTag=(T_NIC,T_RODOKMEN,T_OSOBA,T_ID,T_JMENO,T_PRIJMENI,T_POHLAVI,T_NAROZENI,T_UMRTI,T_MATKA,T_OTEC);
  TFile=class (TObject)
     private
       fBuf:pointer;
       fBufVel:integer;
       fAktPos:pointer;
       fKonecPos:pointer;
     public
     constructor Create(nz:String);
     procedure Free;
     function ZiskejZnak:char;
     function Eof:boolean;
    end;
  TPohlavi=(P_NEDEF,P_ZENA,P_MUZ);
  TClovek= class (TObject)
    public
      fID:string;
      fHasID:boolean;
      fJmeno:string;
      fPrijmeni:string;
      fPohlavi:TPohlavi;
      fNarozeni:integer;
      fUmrti:integer;
      fMatka:TClovek;
      fMatkaID:string;
      fOtec:TClovek;
      fOtecID:string;
      fPred,fDals:TClovek;{pro dyn. seznam vsech}
      fGJekresl:boolean;
      fGX,fGY:integer;
      fListNum:integer;
      function VytvorPopis:string;
      function VytvorJmeno:string;
      function IsParent(cl:TClovek):boolean;
  end;

  TForm1 = class(TForm)
    Label1: TLabel;
    Image1: TImage;
    ListBox1: TListBox;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    Zavt1: TMenuItem;
    Pidat1: TMenuItem;
    pravy1: TMenuItem;
    Zmnit1: TMenuItem;
    procedure WMPust(var Zprava:TMessage);message WM_DROPFILES;
    procedure FormVytvor(Odesilatel: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure Zavt1Click(Sender: TObject);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Pidat1Click(Sender: TObject);
    procedure Zmnit1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }{TO UDELALI Delphi!!! :-P a ja to nebudu prekladat}
  public
    { Public declarations } {TO UDELALI Delphi!!! :-P a ja to nebudu prekladat}
    procedure Rozbor(var f:Tfile;rodicTag:TTag;lparam:TObject);
    procedure NactiRodo(nz:string;pridat:boolean);
    procedure SpojRodice;
    procedure SpoctiPozice;
    procedure KresliRodoKmen;
    procedure ZvyrazniCloveka(cl:TClovek);
    procedure Zavrit;
    procedure Aktualizuj;
  end;



const Vel=25;
      Mezera=5;
      VelM=Vel-2*Mezera;

var
  Form1: TForm1;
  Rodokmen:TClovek;{ukazatel na prvniho}
  RodoIDs:TStringList;{seznam ID s ukazatelama na tridu s daty :-)}
  starejZvyr:TClovek=nil;

implementation

uses editUnit;

{$R *.DFM}

function Tclovek.IsParent(cl:TClovek):boolean;
begin
  result:=false;
  if cl=self then begin result:=true; exit; end;
  if assigned(fmatka) then result:=fMatka.IsParent(cl);
  if not result and assigned(fotec) then result:=fOtec.IsParent(cl);
end;

constructor TFile.Create(nz:string);
var f:file;
begin
  inherited Create;
  assignfile(f,nz);
  filemode:=0;{pouze pro cteni}
  reset(f,1);
  fBufVel:=filesize(f);
  GetMem(fBuf,fBufVel);
  BlockRead(f,fBuf^,fBufVel);
  closefile(f);
  fAktPos:=fBuf;
  fKonecPos:=pointer(integer(fBuf)+fBufVel);
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TFile.Free;
begin
  FreeMem(fBuf,fBufVel);
  inherited Free;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function TFile.ZiskejZnak:char;
begin
  if integer(fAktPos)>integer(fKonecPos) then raise EInOutError.Create('Cteni za koncem souboru!!!');
  result:=pchar(fAktPos)^;
  inc(integer(fAktPos));
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function TFile.Eof:boolean;
begin
  result:= integer(fAktPos)>integer(fKonecPos);
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function TClovek.VytvorPopis:string;
var pch:char;
    snar,sumr:string;{tex narozeni/umrti}
//    smatjm,sotcjm:string;{jmeno matky/otce}
begin
  if fpohlavi=P_MUZ then
    pch:='M'
  else
    if fpohlavi=P_ZENA then
      pch:='Z'
    else
      pch:='?';
  if fNarozeni=0 then
    snar:='*????'
  else
    sNar:='*'+inttostr(fNarozeni);
  if fUmrti=0 then
    sumr:='T????'
  else
    sumr:='T'+inttostr(fUmrti);

  result:=Format('%6s - %10s %10s (%s) %s - %s',[fid,fJmeno,fPrijmeni,pch,sNar,sumr]);
  if fMatka<>nil then begin
    result:=result+' M: '+fMatka.fID;
  end;
  if fotec<>nil then begin
    result:=result+' O: '+fotec.fID;
  end;

//  result:=fid:6+' - '+fJmeno:10+' '+fPrijmeni:10+' ('+pch+') '+sNar+' - '+sumr;
end;
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function TClovek.VytvorJmeno:string;
begin
  result:=fJmeno+' '+fPrijmeni;
end;
////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function ZiskejZnak(var f:Tfile):char;
const BileZnaky=[#0..#32];{to, co se preskoci...}
var ch:char;
begin
  ch:=#0;
//  seek(f,2222555);
//  while (ch in BileZnaky){and not eof(f)} do read(f,ch);
  while (ch in BileZnaky)and not f.eof do ch:=f.ziskejZnak;
  result:=ch;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function ZiskejZnakVse(var f:Tfile):char;
begin
  result:=f.ziskejZnak;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function ZiskejTag(var f:tfile):string;
var ch:char;
    s:string;
begin
  s:='';
  ch:=ZiskejZnak(f);
{  if ch='<' then begin}
  if ch='<' then
    ch:=ZiskejZnak(f);
  while ch<>'>' do begin
    s:=s+ch;
    ch:=ZiskejZnak(f);
  end;
{ end else begin
 //  {CHYBA}
{ end;}
 result:=s;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

function ZiskejData(var f:tfile):string;
var ch:char;
    s:string;
    i,c:integer;
begin
  s:='';
  ch:=ZiskejZnak(f);
  while ch<>'<' do begin
    s:=s+ch;
    ch:=ZiskejZnakVse(f);
  end;
  result:=s;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Rozbor(var f:tfile;rodicTag:TTag;lparam:TObject);
var ch:char;
    s:string;
    cl:TClovek;
begin
  case rodicTag of
    T_NIC:begin
            s:=ZiskejTag(f);
            if (s<>'') and (s[length(s)]<>'/') then if s='rodokmen' then
              Rozbor(f,T_RODOKMEN,nil);
          end;
    T_RODOKMEN:begin
            s:=ZiskejTag(f);
            while (s<>'')and (s[1]<>'/') do begin
              if (s[length(s)]<>'/') then
                if s='osoba' then begin
                  cl:=TClovek.Create;
                  Rozbor(f,T_OSOBA,cl);
                  if cl.fHasID then begin
                    cl.fPred:=Rodokmen;
                    Rodokmen:=cl;
                  end else begin
                    cl.free;
                  end;
                end;
              s:=ZiskejTag(f);
            end;

               end;
    T_OSOBA:begin
              s:=ZiskejTag(f);
              cl:=Tclovek(lparam);
            while (s<>'')and (s[1]<>'/') do begin
              if (s[length(s)]<>'/') then begin
                if s='id' then begin
                  cl.fid:=ZiskejData(f);
                  RodoIDs.objects[RodoIDs.Add(cl.fid)]:=cl;
                  cl.fHasID:=true;
                end;
                if s='jmeno' then cl.fjmeno:=ZiskejData(f);
                if s='prijmeni' then cl.fprijmeni:=ZiskejData(f);
                if s='pohlavi' then begin
                  s:=ZiskejData(f);
                  if s<>'' then
                    case upcase(s[1]) of
                      'M':cl.fPohlavi:=P_MUZ;
                      'Z':cl.fPohlavi:=P_ZENA;
                    end;
                end;
                if s='narozeni' then cl.fnarozeni:=strtointDef(ZiskejData(f),0);
                if s='umrti' then cl.fUmrti:=strtointDef(ZiskejData(f),0);
                if s='matka' then cl.fMatkaID:=ZiskejData(f);
                if s='otec' then cl.fOtecID:=ZiskejData(f);
                s:=ZiskejTag(f);//nacte konec tagu napr: </id> - uz nejsou zadny vnoreny....
              end;
              s:=ZiskejTag(f);
            end;
            end;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.SpojRodice;
var cl:TClovek;
    i:integer;
begin
  cl:=Rodokmen;
  while cl<>nil do begin
    if cl.fMatkaID<>'' then begin
      i:=rodoids.IndexOf(cl.fMatkaID);
      if i>=0 then cl.fmatka:=TClovek(RodoIDs.objects[i]);
    end;
    if cl.fOtecID<>'' then begin
      i:=rodoids.IndexOf(cl.fOtecID);
      if i>=0 then cl.fOtec:=TClovek(RodoIDs.objects[i]);
    end;
    cl:=cl.fPred;
  end;

end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.NactiRodo(nz:string;pridat:boolean);
var f:tfile;
    ch:char;
    s:string;
    cl:TClovek;
begin
  f:=tfile.create(nz);
  if not pridat then Zavrit;
  Rozbor(f,T_NIC,nil);
  SpojRodice;
  Aktualizuj;
{  SpoctiPozice;
  KresliRodokmen;}
{  cl:=Rodokmen;
  listbox1.items.Clear;
  while cl<>nil do begin
    cl.flistnum:=listbox1.Items.AddObject(cl.VytvorPopis,cl);
    cl:=cl.fPred;
  end;   }
  f.free;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.WMPust(var Zprava:TMessage);
var i:integer;
    s:string[255];
begin
  i:=DragQueryFile(Zprava.WParam,$ffffffff,nil,0);{pocet souboru}
  if i=1 then
    s[0]:=char(DragQueryFile(Zprava.WParam,0,@s[1],255));{nacist cestu k souboru}
  DragFinish(Zprava.wparam);
//  memo1.lines.loadfromfile(s);{nacist soubor}
  NactiRodo(s,false);
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.FormVytvor(Odesilatel: TObject);
begin
  DragAcceptFiles(Handle,true);{zapne podporu Tahni&Pust (VSE v ceskem jazyce)}
  RodoIDs:=TStringList.Create;
  Rodokmen:=nil;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.FormDestroy(Sender: TObject);
var cl,x:TClovek;
begin
  RodoIDs.Free;
  cl:=Rodokmen;
  while cl<>nil do begin
    x:=cl;
    cl:=cl.fPred;
    x.free;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.SpoctiPozice;
var cl:TClovek;
    x,y:integer;//souradnice v rodokmenu
    pocet:integer;//pocet lidi na radky ~ x
    mpocet:integer;//pocet nejvice lidi na radku
begin
  cl:=Rodokmen;
  while cl<>nil do begin
    cl.fGJekresl:=false;
    cl:=cl.fPred;
  end;
  y:=0;
  pocet:=1;//pouze pro vstup do while..do
  mpocet:=0;
  while pocet>0 do begin
    x:=0;
    pocet:=0;
    cl:=Rodokmen;
    while cl<>nil do begin
      if (not cl.fGJekresl) and ((cl.fMatka=nil)or((cl.fMatka.fGJekresl)and(cl.fMatka.fGY<y)))and((cl.fOtec=nil)or((cl.fOtec.fGJekresl)and(cl.fOtec.fGY<y))) then begin
        cl.fGJekresl:=true;
        cl.fGX:=x;
        cl.fGY:=y;
        inc(x);
        inc(pocet);
      end;
      cl:=cl.fPred;
    end;
    inc(y);
    if pocet>mpocet then mpocet:=pocet;
  end;
  image1.Width:=mpocet*Vel;
  image1.picture.bitmap.Width:=image1.width;
  image1.height:=pred(y)*vel;
  image1.picture.bitmap.Height:=image1.Height;
  image1.canvas.Brush.Color:=clWhite;
  image1.canvas.Pen.color:=clWhite;
  image1.Canvas.Rectangle(0,0,image1.Width,image1.Height);
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.KresliRodokmen;
var cl:TClovek;
    x,y:integer;
begin
  starejZvyr:=nil;
  cl:=Rodokmen;
  if not cl.fGJekresl then SpoctiPozice;
  while cl<>nil do begin
        x:=cl.fgx;y:=cl.fgy;
        image1.Canvas.pen.Color:=clBlack;
        case cl.fPohlavi of
          P_NEDEF:image1.Canvas.brush.Color:=RGB(192,192,192);
          P_ZENA:image1.Canvas.brush.Color:=RGB(255,192,192);
          P_MUZ:image1.Canvas.brush.Color:=RGB(192,192,255);
        end;
        image1.Canvas.Rectangle(x*Vel+Mezera,y*Vel+Mezera,x*Vel+Vel-Mezera,y*Vel+Vel-Mezera);
    cl:=cl.fPred;
  end;
  cl:=Rodokmen;
  while cl<>nil do begin
        x:=cl.fgx;y:=cl.fgy;
        if assigned(cl.fMatka) then begin
          image1.Canvas.pen.Color:=clRed;
          image1.Canvas.MoveTo(x*Vel+Vel div 2,y*Vel+Mezera+VelM div 3);
          image1.Canvas.LineTo(cl.fMatka.fgx*Vel+Vel div 2,cl.fMatka.fgy*Vel+VelM+Mezera-VelM div 3);
        end;
        if assigned(cl.fOtec) then begin
          image1.Canvas.pen.Color:=clBlue;
          image1.Canvas.MoveTo(x*Vel+Vel div 2,y*Vel+Mezera+VelM div 3);
          image1.Canvas.LineTo(cl.fOtec.fgx*Vel+Vel div 2,cl.fOtec.fgy*Vel+VelM+Mezera-VelM div 3);
        end;
    cl:=cl.fPred;
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.ZvyrazniCloveka(cl:TClovek);
var x,y:integer;
begin
  if starejZvyr=cl then exit;
    image1.canvas.pen.Style:=psInsideFrame;
    image1.canvas.pen.Mode:=pmNot;
    image1.Canvas.pen.Width:=2;
  if starejZvyr<>nil then begin
    x:=starejZvyr.fgx;
    y:=starejZvyr.fgy;
    image1.canvas.Rectangle(x*Vel+Mezera-2,y*Vel+Mezera-2,succ(x)*Vel-Mezera+2,succ(y)*Vel-Mezera+2);
  end;
  starejZvyr:=cl;
  if starejZvyr<>nil then begin
    x:=starejZvyr.fgx;
    y:=starejZvyr.fgy;
    image1.canvas.Rectangle(x*Vel+Mezera-2,y*Vel+Mezera-2,succ(x)*Vel-Mezera+2,succ(y)*Vel-Mezera+2);
  end;
    image1.canvas.pen.Style:=psSolid;
    image1.canvas.pen.Mode:=pmCopy;
    image1.Canvas.pen.Width:=1;

end;


////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.ListBox1Click(Sender: TObject);
begin
  ZvyrazniCloveka(TClovek(listbox1.Items.Objects[listbox1.ItemIndex]));
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Konec1Click(Sender: TObject);
begin
  close;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Otevt1Click(Sender: TObject);
begin
  if opendialog1.Execute then begin
    NactiRodo(opendialog1.filename,false);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Pidat1Click(Sender: TObject);
begin
  if opendialog1.Execute then begin
    NactiRodo(opendialog1.filename,true);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Zavrit;
var cl,x:TClovek;
begin
  listbox1.Items.Clear;
  image1.Width:=0;
  image1.Height:=0;
  rodoIDs.Clear;
  cl:=Rodokmen;
  starejZvyr:=nil;
  while cl<>nil do begin
    x:=cl;
    cl:=cl.fPred;
    x.free;
  end;
  Rodokmen:=nil;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Zavt1Click(Sender: TObject);
begin
  Zavrit;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var cl,fcl:TClovek;
begin
  cl:=rodokmen;
  fcl:=nil;
  x:=x div Vel;
  y:=y div Vel;
  while (cl<>nil)and(fcl=nil) do begin
    if (x=cl.fGX)and(y=cl.fgY) then fcl:=cl;
    cl:=cl.fPred;
  end;
  if assigned(fcl) then begin
    listbox1.Itemindex:=fcl.fListNum;
    ListBox1Click(sender);
  end;
end;

////////////////////////////////////////////////////////////////////////////////
//****************************************************************************//
////////////////////////////////////////////////////////////////////////////////

procedure TForm1.Zmnit1Click(Sender: TObject);
var cl,clw:Tclovek;
    im,io:integer;
begin
  if listbox1.ItemIndex<0 then exit;
  cl:=TClovek(listbox1.Items.Objects[listbox1.ItemIndex]);
  with OKBottomDlg do begin
    edit1.text:=cl.fJmeno;
    edit2.text:=cl.fPrijmeni;
    combobox1.itemindex:=integer(cl.fPohlavi);
    spinedit1.Value:=cl.fNarozeni;
    spinedit2.Value:=cl.fUmrti;
    combobox2.items.clear;
    combobox3.items.clear;
    combobox2.items.addobject('[dn]',nil);
    combobox3.items.addobject('[dn]',nil);
    clw:=rodokmen;
    combobox2.itemindex:=0;
    combobox3.itemindex:=0;
    while assigned(clw) do begin
      case clw.fPohlavi of
        P_NEDEF:begin
                  im:=combobox2.items.addobject(clw.VytvorJmeno,clw);
                  io:=combobox3.items.addobject(clw.VytvorJmeno,clw);
                end;
        P_ZENA:begin
                  im:=combobox2.items.addobject(clw.VytvorJmeno,clw);
                  io:=0;
                end;
        P_MUZ:begin
                  io:=combobox3.items.addobject(clw.VytvorJmeno,clw);
                  im:=0;
                end;
      end;
      clw:=clw.fpred;
      if cl.fMatka=clw then combobox2.itemindex:=im;
      if cl.fOtec=clw then combobox3.itemindex:=io;
    end;
    showmodal;
    if modalresult=mrok then begin
      cl.fJmeno:=edit1.text;
      cl.fPrijmeni:=edit2.text;
      cl.fPohlavi:=TPohlavi(combobox1.itemindex);
      cl.fNarozeni:=spinedit1.Value;
      cl.fUmrti:=spinedit2.Value;
      cl.fmatka:=tClovek(combobox2.items.objects[combobox2.itemindex]);
      cl.fotec:=tClovek(combobox3.items.objects[combobox3.itemindex]);
      Aktualizuj;
    end;
  end;
end;

procedure TForm1.Aktualizuj;
var cl:TClovek;
begin
  SpoctiPozice;
  KresliRodokmen;
  cl:=Rodokmen;
  listbox1.items.Clear;
  while cl<>nil do begin
    cl.flistnum:=listbox1.Items.AddObject(cl.VytvorPopis,cl);
    cl:=cl.fPred;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin

 Aktualizuj;
end;

end.
